#------------------------------------------------------------------------------
#
#	Apple Macintosh Developer Technical Support
#
#	Program:	DTS.Lib_ctlhandler
#	File:		DTS.Lib_ctlhandler.make
#
#	Copyright  1988-1994 Apple Computer, Inc.
#	All rights reserved.
#
#------------------------------------------------------------------------------

#	The three possible targets for this makefile
#	The default name is LibName and builds the 68K library
#	PowerPC library is named .PPC and is built with:
#		make -f DTS.Lib_ctlhandler.make DTS.Lib_ctlhandler.PPC
#	The "Fat" version isn't actually fat, it just builds both 68K and 
#		PowerPC versions.  Build it with:
#		make -f DTS.Lib_ctlhandler.make DTS.Lib_ctlhandler.FAT
LibName			=	'DTS.Lib_ctlhandler'
LibNamePPC		=	'DTS.Lib_ctlhandler.PPC'
LibNameFAT		=	'DTS.Lib_ctlhandler.FAT'

DTS.Lib.hdrs    =   ":DTS.Lib.headers:"
projsrc			=	:
obj				= 	:OBJECT:
objppc			= 	:OBJECTPPC:

#	SymOptions and OptOptions are mutually exclusive.  Enable as appropriate
SymOptions		=	-sym on				# turn this on to debug with SADE/R2Db
COptOptions		=	#-opt on
PPCCOptOptions	=	#-opt speed

# CIncludesFolder needs to be set to your Universal Interfaces folder
CIncludesFolder	=	-i "{PPCCIncludes}"
IncludesFolders	=	-i {DTS.Lib.hdrs}
COptions		=	{IncludesFolders} {CIncludesFolder} {SymOptions} {COptOptions} -r -mbg off
PPCCOptions		=	{IncludesFolders} {SymOptions} {PPCCOptOptions} -w conformance -appleext on
LibOptions		=	{SymOptions}
LibOptionsPPC	=	-warn -xm l {SymOptions}

#------------------------------------------------------------------------------
# These are modified default build rules.  These allow us to build using both
# MPW C (68K) and PPCC (PowerPC) from the same set of sources
#------------------------------------------------------------------------------
{obj}				{projsrc}

.c.o				.c
	{C} {COptions} {CAltOptions} {DepDir}{Default}.c -o {TargDir}{Default}.c.o

{objppc}			{projsrc}

.o					.c
	PPCC {PPCCOptions} {DepDir}{Default}.c -o {TargDir}{Default}.o

#------------------------------------------------------------------------------
# These are the objects that we want to include in the library.
#------------------------------------------------------------------------------
LibObjects		=	
					{obj}CtlHandler.c.o 
					{obj}System6Help.c.o 
					{obj}Help.c.o

LibObjectsPPC	=	
					{objppc}CtlHandler.o 
					{objppc}System6Help.o 
					{objppc}Help.o

{LibNameFAT}		 {LibName} {LibNamePPC}

{LibName}			 {LibObjects}
	Lib {LibObjects} {LibOptions} -o {Targ}

{LibNamePPC}		 {LibObjectsPPC}
	PPCLink	{LibObjectsPPC} {LibOptionsPPC}	-o {Targ}

